﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.Intrinsics.X86;
using System.Text;
using System.Threading.Tasks;
using System.Collections.Concurrent;

namespace Souběh
{
    public class Přepravka
    {
        private long PočetDodávek
        {
            get
            {
                return Interlocked.Read(ref obal.početDodávek);
            }
        }

        public long VelikostFronty => fronta.Count;
        public Přepravka() => this.obal = new Obal(new Bod(0, 0, 1), 0);

        public void PřijmiBod(Obal obal)
        {
            fronta.Enqueue(obal);
        }
        public override string ToString()
        {
            while (!fronta.TryDequeue(out obal))
            {
                Thread.Sleep(10);
            }
            return obal.početDodávek.ToString() + ": " + obal.Bod.ToString();
        }
        public string Data => ToString();

        private Obal obal;
        private Bod bod;
        private ConcurrentQueue<Obal> fronta = new();

    }
}
