﻿public class Řadič
{
    public bool Napsáno { get; set; } = false;
}

public class Program
{
    static void ČekejNa(Řadič řadič)
    {
        while (!řadič.Napsáno)
        {
            lock (řadič)
            {
                Monitor.Wait(řadič);
            }
        }
    }
    public static void BěhKočky()
    {
        lock (píšeKočka)
        {
            Console.WriteLine("Kočka leze dírou");
            píšeKočka.Napsáno = true;
            píšePes.Napsáno = false;

            Monitor.Pulse(píšeKočka);
            

            while (!píšePes.Napsáno)
            {
                lock (píšePes)
                {
                    Console.WriteLine("Signalizuji psovi");
                    Monitor.Wait(píšePes);
                }
            }
        }
    }

    public static void BěhPsa()
    {
        while (!píšeKočka.Napsáno)
        {
            Console.WriteLine("Čekám na zámek od kočky");
            lock (píšeKočka)
            {
                Console.WriteLine("Čekám na kočku");
                Monitor.Wait(píšeKočka);
            }
        }
        Console.WriteLine("Pes oknem");
        hotovo.Napsáno = true;
        lock (hotovo)
        {
            Monitor.Pulse(hotovo);
        }
    }
    private static void Main()
    {
        Thread podprocesKočky = new(BěhKočky)
        {
            IsBackground = true
        };
        Thread podprocesPsa = new(BěhPsa)
        {
            IsBackground = true
        };
        podprocesKočky.Start();
        podprocesPsa.Start();
        while (!hotovo.Napsáno)
        {
            lock (hotovo)
            {
                Monitor.Wait(hotovo);
            }
        }
        Console.WriteLine("\nVypsáno jest.");
    }

    public static readonly Řadič píšeKočka = new();
    public static readonly Řadič píšePes = new();
    public static readonly Řadič hotovo = new();
}

