﻿using System.Data;
using System;
using System.Data.SqlClient;

namespace db1
{
    class Program
    {
        private static readonly string připojovacíŘetězec = @"Data Source=(localdb)\MSSQLLocalDB;Initial Catalog=D:\TEMP\NET\TEST.MDF;Integrated Security=True;Connect Timeout=30;Encrypt=False;TrustServerCertificate=False;ApplicationIntent=ReadWrite;MultiSubnetFailover=False";

        private static readonly string dotaz = "select * from Účty";
        private static readonly string dotazPrůmCena = "select AVG(Cena) from Kniha";
        private static readonly string vložení = "insert into Účty (Id, Stav) values (10, 54321)";

        private static readonly string aktualizace1 = "Update Účty set stav = stav - 1000 where ID = 10";
        private static readonly string aktualizace2 = "Update Účty set stav = stav + 1000 where ID = 1";


        private static void Dotaz()
        {
            using (SqlConnection připojení = new SqlConnection())
            {
                připojení.ConnectionString = připojovacíŘetězec;
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = dotaz;
                připojení.Open();
                SqlDataReader čtečka = příkaz.ExecuteReader();
                while(čtečka.Read())
                {
                    Console.WriteLine("Účet č: " + čtečka[0].ToString() + " stav: " + čtečka[1].ToString());
                }
            } 
        }

        private static void PrůměrnáCena()
        {
            using (SqlConnection připojení = new SqlConnection())
            {
                připojení.ConnectionString = připojovacíŘetězec;
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = dotazPrůmCena;
                připojení.Open();
                int průměrnáCena = (int)příkaz.ExecuteScalar();
                Console.WriteLine($"průměrná cena knih: {průměrnáCena}");
            }
        }

        private static void Vložení()
        {
            using (SqlConnection připojení = new SqlConnection())
            {
                připojení.ConnectionString = připojovacíŘetězec;
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = vložení;
                připojení.Open();
                příkaz.ExecuteNonQuery();
            }
        }

        private static void Převod()
        {
            SqlConnection připojení = null;
            SqlTransaction transakce = null;
            try
            {
                připojení = new SqlConnection(připojovacíŘetězec);
                připojení.Open();
                transakce = připojení.BeginTransaction(System.Data.IsolationLevel.Serializable);
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.Transaction = transakce;
                příkaz.CommandText = aktualizace1;
                int i = příkaz.ExecuteNonQuery();
                if (i != 1) throw new Exception("chyba účtu 1");
                příkaz.CommandText = aktualizace2;
                i = příkaz.ExecuteNonQuery();
                if (i != 1) throw new Exception("chyba účtu 2");
                transakce.Commit();
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                if(transakce != null)
                {
                    transakce.Rollback();
                }
            }
            finally
            {
                if (připojení != null) připojení.Close();
            }
        }
        static void Main(string[] args)
        {
            //Dotaz();
            //PrůměrnáCena();
            //Vložení();
            Dotaz();
            Převod();
            Console.WriteLine("---");
            Dotaz();
        }
    }
}
